<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: Server.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: Server.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const express = require("express");
const http = require("http");
const Config_1 = require("./config/Config");
const Logger_1 = require("./utils/Logger");
const middleware_1 = require("./routers/middleware");
const BaseRouter_1 = require("./routers/BaseRouter");
const index_1 = require("./models/index");
const ErrorHandler_1 = require("./ErrorHandler");
/**
 * Initialises the server configuration - Setup of middleware
 * and routes.
 * @class
 * @author Farooq Ilyas
 */
class Server {
    /**
     * @constructor
     */
    constructor() {
        this.app = express();
        this.app.use(new middleware_1.Middleware().configuration);
        this.app.use("/", new BaseRouter_1.BaseRouter().routes);
        this.app.use("/", new ErrorHandler_1.CustomErrorHandler().error);
        this.server = http.createServer(this.app);
    }
    /**
     * Handles and throws errors
     * @param {NodeJS.ErrnoException} error error
     */
    onError(error) {
        if (error.syscall) {
            throw error;
        }
        let port = Config_1.configs.getServerConfig().port;
        let bind = `Port ${port}`;
        switch (error.code) {
            case "EACCES":
                Logger_1.logger.error(`[EACCES] ${bind} requires elevated privileges.`);
                process.exit(1);
                break;
            case "EADDRINUSE":
                Logger_1.logger.error(`[EADDRINUSE] ${bind} is already in use.`);
                process.exit(1);
                break;
            default:
                throw error;
        }
    }
    ;
    /**
     * Logs the port information when a server listens
     */
    onListening() {
        console.log("in on listening");
        let address = this.server.address();
        let bind = `port ${Config_1.configs.getServerConfig().port}`;
        Logger_1.logger.info(`Listening on ${bind}.`);
    }
    ;
    /**
     * Starts the server and synchronises the database.
     * A worker is assigned to each CPU core with each
     * worker listening on the assigned port.
     */
    start() {
        index_1.sequelize.sync().then(() => {
            Logger_1.logger.info("Database synced.");
        }).catch((error) => {
            Logger_1.logger.error(error.message);
        });
        this.server.listen(3000);
        this.server.on("error", error => this.onError(error));
        this.server.on("listening", () => this.onListening());
    }
    /**
     * Stops the server.
     */
    stop() {
        this.server.close();
        process.exit(0);
    }
}
let server = new Server();
server.start();
process.on("SIGINT", () => {
    server.stop();
});
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="BaseRouter.html">BaseRouter</a></li><li><a href="Configs.html">Configs</a></li><li><a href="CustomErrorHandler.html">CustomErrorHandler</a></li><li><a href="Database.html">Database</a></li><li><a href="DBConfig.html">DBConfig</a></li><li><a href="LoggingConfiguration.html">LoggingConfiguration</a></li><li><a href="Middleware.html">Middleware</a></li><li><a href="Server.html">Server</a></li><li><a href="ServerConfiguration.html">ServerConfiguration</a></li><li><a href="UserController.html">UserController</a></li><li><a href="UserModel.html">UserModel</a></li><li><a href="UserRouter.html">UserRouter</a></li><li><a href="UserService.html">UserService</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Jul 02 2018 23:16:09 GMT+0100 (GMT Daylight Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
